/**********************************************************************************
 * project:    
 * file:        debug.h
 * date:
 * author:      volker bosch  <bosch@iema.uni-stuttgart.de>
 * 
 * description: 
 *
 **********************************************************************************/

#ifndef HDR_DEBUG_H
#define HDR_DEBUG_H

#ifndef extern
  extern unsigned long	DebugLevel;
#else
  unsigned long	DebugLevel	= 0x00ul;
#endif

#ifdef DEBUG
#  define DBG_PRINTF(Lvl, Fmt, a...) { if( (DebugLevel & DBG_FORCE)|| 	\
					   ((Lvl) & DBG_FORCE)	   ||           \
					   ((Lvl) & DebugLevel)     ) {		\
					printf(Fmt, ## a);     	  		\
					fflush(stdout);				\
				      } 					\
				   }

#  define DBG_COND_PRINTF(Lvl, Cnd, Fmt, a...) 					\
				{ if((Cnd) 				&& 	\
					( (DebugLevel & DBG_FORCE) ||		\
					  ((Lvl) & DBG_FORCE)      ||		\
					  ((Lvl) & DebugLevel)	    )  ) {	\
					printf(Fmt, ## a); 			\
					fflush(stdout);				\
				}						\
		}				   
#else
#  define DBG_PRINTF(Lvl, Fmt, a...)
#  define DBG_COND_PRINTF(Lvl, Cnd, Fmt, a...)
#endif

/*------------------ Global ------------------------------------------*/
#define DBG_MAIN		0x00000001lu
#define DBG_IO			0x00000002lu
#define DBG_LOAD		0x00000004lu

/*------------------ Unbedingte Ausgabe -------------------------------*/
#define DBG_FORCE		0x80000000lu 

/***********************************************************************/
#endif /* HDR_DEBUG_H */
